
public class HashTableDriver {
	
	private static final int NUMBER_OF_PERSONS = 17_000;
	private static final int RANDOM_MULTIPLIER = 900_000_000;

	public static void main(String[] args) {
		
		Integer[] keys = new Integer[NUMBER_OF_PERSONS];
		
		for ( int i = 0 ; i < keys.length ; i++ ) {
			keys[i] = (int) (Math.random()*RANDOM_MULTIPLIER);
		}

		for (HashTable.ProbeType probeType : HashTable.ProbeType.values()) {
			System.out.println("\n\nProbe Type = " + probeType);
			HashTable<Person<Integer>, Integer> ht = new HashTable<Person<Integer>, Integer>();
			ht.setProbeType(probeType);
			
			for ( int i = 0 ; i < keys.length ; i++ ) {
				Person<Integer> p = new Person<Integer>(keys[i]);
				Person<Integer> oldPerson = ht.insert(p);
			}
			System.out.println("HashTable Size = " + ht.size());
			System.out.println("Total Nummber Of Probes for insert = " + ht.getTotalNumberOfProbes());
			
			ht.setTotalNumberOfProbes(0);
			
			for ( int i = 0 ; i < keys.length ; i++ ) {
				Person<Integer> p = ht.get(keys[i]);
				if (p == null) {
					throw new NullPointerException("Did not find key = " + keys[i] + " in the HashTable"); 
				}
			}
			System.out.println("Total Nummber Of Probes for get    = " + ht.getTotalNumberOfProbes());
			
			ht.setTotalNumberOfProbes(0);
			
			for ( int i = 0 ; i < keys.length ; i++ ) {
				Person<Integer> p = ht.remove(keys[i]);
				if (p == null) {
					throw new NullPointerException("Did not find key = " + keys[i] + " in the HashTable"); 
				}
			}
			System.out.println("Total Nummber Of Probes for remove = " + ht.getTotalNumberOfProbes());
			System.out.println("HashTable Size = " + ht.size());
		}
	}

}
